SystemOrganization addCategory: #PharOffice!
SystemOrganization addCategory: #'PharOffice-Email'!
SystemOrganization addCategory: #'PharOffice-Graphics'!
SystemOrganization addCategory: #'PharOffice-Presenter'!
SystemOrganization addCategory: #'PharOffice-Spreadsheet'!
SystemOrganization addCategory: #'PharOffice-Tools'!
SystemOrganization addCategory: #'PharOffice-Writer'!

Morph subclass: #POGCanvas
	instanceVariableNames: 'area paintingColor toolType toolSize parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Graphics'!

POGCanvas class
	instanceVariableNames: 'previous current'!

!POGCanvas commentStamp: 'dusty 8/17/2012 10:08' prior: 0!
Canvas on which to draw!

POGCanvas class
	instanceVariableNames: 'previous current'!

!POGCanvas methodsFor: 'accessing' stamp: 'dusty 8/17/2012 11:43'!
area
	^ area ifNil: [
		area := FormCanvas extent: (Display extent).
		self clear.
		area]! !

!POGCanvas methodsFor: 'accessing' stamp: 'dusty 8/21/2012 12:17'!
clear
	self parent createHistory.
	self extent: (Display extent).
	self area fillColor: Color white.
	self changed! !

!POGCanvas methodsFor: 'drawing' stamp: 'dusty 8/7/2012 12:39'!
drawOn: aCanvas
	aCanvas drawImage: self area form at: self position! !

!POGCanvas methodsFor: 'geometry' stamp: 'dusty 8/17/2012 11:44'!
extent: aPoint
	| newArea |
	super extent: (Display extent).
	newArea := FormCanvas extent: (Display extent).
	newArea 
		fillColor: Color white;
		drawImage: self area form at: 0@0.
	area := newArea
	! !

!POGCanvas methodsFor: 'event handling' stamp: 'dusty 8/7/2012 12:39'!
handlesMouseDown: evt
	^ true! !

!POGCanvas methodsFor: 'event handling' stamp: 'dusty 8/17/2012 13:27'!
mouseMove: anEvent
	self toolType = 'circle' ifTrue: [self mouseMoveCircle: anEvent].
	self toolType = 'square' ifTrue: [self mouseMoveSquare: anEvent].! !

!POGCanvas methodsFor: 'event handling' stamp: 'dusty 8/17/2012 13:28'!
mouseMoveCircle: anEvent
				self area balloonFillOval: (Rectangle center: anEvent cursorPoint - self position extent: (self toolSize)) 
				fillStyle: (self paintingColor) 
				borderWidth: 0 
				borderColor: (Color transparent).
				self invalidRect: (self fullBounds)! !

!POGCanvas methodsFor: 'event handling' stamp: 'dusty 8/17/2012 13:29'!
mouseMoveSquare: anEvent
				self area balloonFillRectangle: (Rectangle center: anEvent cursorPoint - self position extent: (self toolSize)) 
				fillStyle: (self paintingColor).	
				self invalidRect: (self fullBounds)! !

!POGCanvas methodsFor: 'event handling' stamp: 'dusty 8/19/2012 14:49'!
mouseUp: evt
	self parent createHistory.
	self changed! !

!POGCanvas methodsFor: 'accessing' stamp: 'dusty 8/7/2012 12:39'!
paintingColor
	^ paintingColor ifNil: [paintingColor := Color black]! !

!POGCanvas methodsFor: 'accessing' stamp: 'dusty 8/7/2012 12:39'!
paintingColor: aColor
	paintingColor := aColor! !

!POGCanvas methodsFor: 'as yet unclassified' stamp: 'dusty 8/19/2012 14:25'!
parent
	^parent! !

!POGCanvas methodsFor: 'as yet unclassified' stamp: 'dusty 8/19/2012 14:25'!
parent: anObj
	parent := anObj! !

!POGCanvas methodsFor: 'as yet unclassified' stamp: 'dusty 8/17/2012 13:29'!
toolSize
	^toolSize ifNil: [toolSize := 4@4. toolSize]! !

!POGCanvas methodsFor: 'as yet unclassified' stamp: 'dusty 8/17/2012 13:29'!
toolSize: anExtent
	toolSize := anExtent! !

!POGCanvas methodsFor: 'as yet unclassified' stamp: 'dusty 8/17/2012 13:20'!
toolType
	^toolType ifNil: [toolType := 'circle'. toolType]! !

!POGCanvas methodsFor: 'as yet unclassified' stamp: 'dusty 8/17/2012 13:17'!
toolType: aToolType
	toolType := aToolType! !

TextMorph subclass: #POWTextArea
	instanceVariableNames: 'area'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Writer'!

!POWTextArea commentStamp: '<historical>' prior: 0!
writing area for Pharo Office Writer
!

!POWTextArea methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 13:05'!
initialize
	super initialize.! !

StandardWindow subclass: #POOWindow
	instanceVariableNames: 'menubar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice'!

!POOWindow methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 12:42'!
initialize
	super initialize.
	self installMenubar.
	self window openInWorld.
	self window fullscreen.! !

!POOWindow methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 12:41'!
installMenubar
	self 	addMorph: self menubar
		fullFrame: (
			LayoutFrame
				fractions: (0@0 corner: 1@0)
				offsets: (0@0 corner:  0@ self menubar minExtent y))! !

!POOWindow methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 12:40'!
menubar
	^ menubar ifNil: [ | fileMenu editMenu |
		fileMenu := self window newMenu.
		fileMenu addToggle: 'Open'	target: self	selector: #nyi.
		fileMenu addToggle: 'Save'	target: self	selector: #nyi.
		fileMenu addToggle: 'Save As' target: self selector: #nyi.
		fileMenu addToggle: 'Exit'	target: self	selector: #exit.
				
		editMenu := self window newMenu.
		editMenu addToggle: 'Undo'	target: self	selector: #nyi.
		editMenu addToggle: 'Redo'	target: self	selector: #nyi.
		editMenu addToggle: 'Copy'	target: self	selector: #nyi.
		editMenu addToggle: 'Cut' target: self	selector: #nyi.
		editMenu addToggle: 'Paste' target: self	selector: #nyi.
		
		menubar := self window newToolDockingBar.
		menubar add: 'File'	font: (self window theme menuBarFont) icon: nil help: 'File operations'	subMenu: fileMenu.
		menubar add: 'Edit'	font: (self window theme menuBarFont) icon: nil help: 'Edit operations'	subMenu: editMenu.
		menubar
		]! !

!POOWindow methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 13:00'!
nyi
	self inform: 'Not Yet Implemented'! !

Object subclass: #POEmail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Email'!

Object subclass: #POGraphics
	instanceVariableNames: 'window menubar toolbar drawingArea current previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Graphics'!

!POGraphics commentStamp: 'dusty 8/17/2012 10:08' prior: 0!
Primary Drawing App!

!POGraphics class methodsFor: 'menu' stamp: 'dusty 8/22/2012 09:19'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'PharOffice Graphical Editor')
			parent: #PharOffice;
			icon: ThemeIcons paintIcon;
			action:[self new]; 
			help: 'PharOffice Graphics'.! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/7/2012 12:39'!
chooseColor
	self drawingArea paintingColor: (self window chooseColor: self drawingArea paintingColor)! !

!POGraphics methodsFor: 'as yet unclassified' stamp: 'dusty 8/21/2012 11:29'!
createHistory
	self current: 
		(self drawingArea imageFormForRectangle: 
			((self drawingArea bounds origin) corner: (self drawingArea area form width)@(self drawingArea area form height))).! !

!POGraphics methodsFor: 'accessing' stamp: 'dusty 8/19/2012 14:21'!
current
	^current! !

!POGraphics methodsFor: 'as yet unclassified' stamp: 'dusty 8/19/2012 14:44'!
current: anArea
	previous := (self current).
	current := anArea.! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/7/2012 13:21'!
draw
	self window alert: 'Tool is Currently Selected'! !

!POGraphics methodsFor: 'accessing' stamp: 'dusty 8/21/2012 19:54'!
drawingArea
	^ drawingArea ifNil: [
		drawingArea := POGCanvas new.
		drawingArea parent: self.
		drawingArea]! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/17/2012 11:16'!
exit
	self window abandon! !

!POGraphics methodsFor: 'initialize-release' stamp: 'dusty 8/21/2012 19:36'!
initialize
	super initialize.
	self installMenubar.
	self installToolbar.
	self installDrawingArea.
	self window openInWorld.
	self window fullscreen.! !

!POGraphics methodsFor: 'initialize-release' stamp: 'dusty 8/21/2012 19:37'!
installDrawingArea
	|aScroller aMorph|
	self drawingArea extent: (Display extent).
	aScroller := ScrollPane new.
	aScroller scroller addMorph: self drawingArea.
	self window addMorph: aScroller frame: (0.02@0.07 corner:0.98@1).
	! !

!POGraphics methodsFor: 'initialize-release' stamp: 'dusty 8/7/2012 12:39'!
installMenubar
	self window 
		addMorph: self menubar
		fullFrame: (
			LayoutFrame
				fractions: (0@0 corner: 1@0)
				offsets: (0@0 corner:  0@ self menubar minExtent y))! !

!POGraphics methodsFor: 'initialize-release' stamp: 'dusty 8/7/2012 12:39'!
installToolbar
	self window 
		addMorph: self toolbar
		fullFrame: (
			LayoutFrame
				fractions: (0@0 corner: 1@0)
				offsets: (0@self menubar minExtent y corner:  0@ self menubar minExtent y + self toolbar minExtent y))! !

!POGraphics methodsFor: 'accessing' stamp: 'dusty 8/21/2012 14:21'!
menubar
	^ menubar ifNil: [ | fileMenu editMenu toolsMenu toolTypeMenu toolSizeMenu|
		fileMenu := self window newMenu.
		fileMenu addToggle: 'Open'	target: self	selector: #open.
		fileMenu addToggle: 'Save'	target: self	selector: #save.
		fileMenu addToggle: 'Save As' target: self selector: #nyi.
		fileMenu addToggle: 'Exit'	target: self	selector: #exit.
				
		editMenu := self window newMenu.
		editMenu addToggle: 'Undo'	target: self	selector: #undo.
		editMenu addToggle: 'Redo'	target: self	selector: #redo.
		editMenu addToggle: 'Copy'	target: self	selector: #nyi.
		editMenu addToggle: 'Cut' target: self	selector: #nyi.
		editMenu addToggle: 'Paste' target: self	selector: #nyi.
		
		toolsMenu := self window newMenu.	
		toolTypeMenu := self window newMenu.	
		toolTypeMenu addToggle: 'Circle Tool' target: self	selector: #toolType: getStateSelector: nil argumentList: {'circle'}.
		toolTypeMenu addToggle: 'Square Tool' target: self	selector: #toolType: getStateSelector: nil argumentList: {'square'}.
			
		toolSizeMenu := self window newMenu.
		toolSizeMenu addToggle: 'Size: 4' target: self selector: #toolSize: getStateSelector: nil argumentList: {4}.
		toolSizeMenu addToggle: 'Size: 8' target: self selector: #toolSize: getStateSelector: nil argumentList: {8}.
		toolSizeMenu addToggle: 'Size: 12' target: self selector: #toolSize: getStateSelector: nil argumentList: {12}.
		toolSizeMenu addToggle: 'Size: 16' target: self selector: #toolSize: getStateSelector: nil argumentList: {16}.
		toolSizeMenu addToggle: 'Size: custom' target: self selector: #toolSizeCustom.
		
		toolsMenu add: 'Tool Type' subMenu: toolTypeMenu.
		toolsMenu add: 'Tool Size' subMenu: toolSizeMenu.
		toolsMenu addToggle: 'Choose Color' target: self selector: #chooseColor.
			
		menubar := self window newToolDockingBar.
		menubar add: 'File'	font: (self window theme menuBarFont) icon: nil help: 'File operations'	subMenu: fileMenu.
		menubar add: 'Edit'	font: (self window theme menuBarFont) icon: nil help: 'Edit operations'	subMenu: editMenu.
		menubar add: 'Tools' font: (self window theme menuBarFont) icon: nil help: 'Tools operations'	subMenu: toolsMenu.
		menubar
		]! !

!POGraphics methodsFor: 'as yet unclassified' stamp: 'dusty 8/17/2012 11:14'!
nyi
	self inform: 'Not Yet Implemented'! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/21/2012 11:15'!
open
	|aPic|
	aPic := UIManager default 
	chooseFileMatching: #('*.gif' '*.bmp' '*.jpg').
	aPic := Form fromFileNamed: aPic.
	self drawingArea clear.
	self drawingArea area setForm: aPic! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/21/2012 12:09'!
open: aForm 
	self drawingArea area setForm: aForm.
	self drawingArea changed.! !

!POGraphics methodsFor: 'accessing' stamp: 'dusty 8/19/2012 14:21'!
previous
	^previous! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/21/2012 11:25'!
redo
	self drawingArea area setForm: self current.
	self drawingArea changed.! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/21/2012 12:59'!
save
	|anImageMorph|
	anImageMorph := ImageMorph withForm: drawingArea area form.
	anImageMorph setNameTo: (self activeModelName).
	anImageMorph exportAsGIF.! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/21/2012 13:01'!
saveAs
	|anImageMorph|
	anImageMorph := ImageMorph withForm: drawingArea area form.
	anImageMorph setNameTo: (self activeModelName).
	anImageMorph exportAsGIF.! !

!POGraphics methodsFor: 'tools' stamp: 'dusty 8/17/2012 14:30'!
toolSize: anInteger
	self drawingArea toolSize: anInteger@anInteger! !

!POGraphics methodsFor: 'tools' stamp: 'dusty 8/17/2012 14:45'!
toolSizeCustom
	|answer number|
	answer := MorphicUIManager new request: 'Enter an number. Max: 32' initialAnswer: '4'.
	answer := answer asString.
	number := answer asInteger.
	number isNil ifTrue: [self inform: answer,' is not a number. Enter a number between 0 and 32'. self toolSizeCustom]
				   ifFalse: [number > 32 ifTrue: [self inform: 'Too Big!! try a smaller number.'. self toolSizeCustom]
				  							  ifFalse: [self toolSize: number]].! !

!POGraphics methodsFor: 'tools' stamp: 'dusty 8/17/2012 14:32'!
toolType:aString
	self drawingArea toolType: aString! !

!POGraphics methodsFor: 'accessing' stamp: 'dusty 8/19/2012 10:05'!
toolbar
	^ toolbar ifNil: [ | tools |
		tools := self window newToolbar: {
			self window
				newButtonFor: self drawingArea getState: nil action: #clear arguments: nil getEnabled: nil 
				labelForm: (UITheme current smallNewIcon scaledToSize: 16@16) help: 'Clear / New'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #save arguments: nil getEnabled: nil
				labelForm: (UITheme current smallSaveAsIcon scaledToSize: 16@16) help: 'Save as Bitmap'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #open arguments: nil getEnabled: nil
				labelForm: (UITheme current openIcon scaledToSize: 16@16) help: 'Open an Image'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #undo arguments: nil getEnabled: nil
				labelForm: (UITheme current smallUndoIcon scaledToSize: 16@16) help: 'Undo'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #redo arguments: nil getEnabled: nil
				labelForm: (UITheme current smallRedoIcon scaledToSize: 16@16) help: 'Redo'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #chooseColor arguments: nil getEnabled: nil
				labelForm: (UITheme current eyedropperIcon scaledToSize: 16@16) help: 'Choose a color to paint with.'.
		}.
		toolbar := self window newToolDockingBar addMorph: tools]! !

!POGraphics methodsFor: 'actions' stamp: 'dusty 8/21/2012 11:30'!
undo
	self previous isNil ifFalse:[
	self drawingArea area setForm: self previous.].
	self drawingArea changed.! !

!POGraphics methodsFor: 'accessing' stamp: 'dusty 8/21/2012 14:20'!
window
 	^ window ifNil: [
		window := StandardWindow labelled: 'PharOffice Graphical Editor'.
		window]! !

Object subclass: #POPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Presenter'!

Object subclass: #POSpreadSheet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Spreadsheet'!

Object subclass: #POTFileManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Tools'!

Object subclass: #POTFonts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Tools'!

Object subclass: #POTXMLParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Tools'!

Object subclass: #POWriter
	instanceVariableNames: 'menubar window textArea toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Writer'!

!POWriter commentStamp: '<historical>' prior: 0!
Primary Application!

!POWriter class methodsFor: 'as yet unclassified' stamp: 'dusty 8/22/2012 09:20'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'PharOffice Document Writer')
			parent: #PharOffice;
			icon: ThemeIcons publishIcon;
			action:[self new]; 
			help: 'PharOffice Writer'.! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 8/21/2012 19:49'!
exit
	self window abandon! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 12:46'!
initialize
	super initialize.
	self installMenubar.
	self installToolbar.
	self installTextArea.
	self window openInWorld.
	self window fullscreen.! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 8/21/2012 19:43'!
installMenubar
	self window 
		addMorph: self menubar
		fullFrame: (
			LayoutFrame
				fractions: (0@0 corner: 1@0)
				offsets: (0@0 corner:  0@ self menubar minExtent y))! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 13:03'!
installTextArea
	|aScroller aMorph|
	self textArea extent: (Display extent).
	aScroller := ScrollPane new.
	aScroller scroller addMorph: self textArea.
	self window addMorph: aScroller frame: (0.02@0.1 corner:0.98@1).! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 12:46'!
installToolbar
	self window 
		addMorph: self toolbar
		fullFrame: (
			LayoutFrame
				fractions: (0@0 corner: 1@0)
				offsets: (0@self menubar minExtent y corner:  0@self menubar minExtent y + self toolbar minExtent y))! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 12:45'!
menubar
	^ window menubar! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 8/21/2012 20:07'!
nyi
	self inform: 'Not Yet Implemented'! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 8/21/2012 20:02'!
textArea
	^ textArea ifNil: [
		textArea := POWTextArea new.
		textArea]! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 13:02'!
toolbar
	^ toolbar ifNil: [ | tools |
		tools := self window newToolbar: {
			self window
				newButtonFor: self getState: nil action: #nyi arguments: nil getEnabled: nil 
				labelForm: (UITheme current smallNewIcon scaledToSize: 16@16) help: 'Clear / New'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #nyi arguments: nil getEnabled: nil
				labelForm: (UITheme current smallSaveAsIcon scaledToSize: 16@16) help: 'Save as Bitmap'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #nyi arguments: nil getEnabled: nil
				labelForm: (UITheme current openIcon scaledToSize: 16@16) help: 'Open an Image'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #nyi arguments: nil getEnabled: nil
				labelForm: (UITheme current smallUndoIcon scaledToSize: 16@16) help: 'Undo'.
			self window newSeparator.
			self window 
				newButtonFor: self getState: nil action: #nyi arguments: nil getEnabled: nil
				labelForm: (UITheme current smallRedoIcon scaledToSize: 16@16) help: 'Redo'.
			self window newSeparator.
		}.
		toolbar := self window newToolDockingBar addMorph: tools]! !

!POWriter methodsFor: 'as yet unclassified' stamp: 'dusty 12/30/2012 12:40'!
window
 	^ window ifNil: [
		window := POOWindow labelled: 'PharOffice Document Writer'.
		window]! !

Object subclass: #PharOfficeCore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharOffice-Tools'!

!PharOfficeCore class methodsFor: 'as yet unclassified' stamp: 'dusty 8/22/2012 09:18'!
menuCommandOn: aBuilder  
	<worldMenu>
	(aBuilder item: #PharOffice)
		order: 1.0;
		target: self;
		icon: ThemeIcons homeIcon! !
